from math import floor


def number_of_matches(s1, s2):
    max_match_distance = floor(max(len(s1), len(s2)) / 2)-1
    match_result = 0
    li = []
    for i, c in enumerate(s1):
        start = max(0, i-max_match_distance)
        end = min(i+max_match_distance+1, len(s2))
        for j, d in enumerate(s2):
            if c == d and j not in li and abs(i-j) <= max_match_distance:
                match_result += 1
                li.append(j)
                break
    return match_result


def number_of_transpositions(s1, s2):
    max_match_distance = floor(max(len(s1), len(s2)) / 2) - 1
    print(f"{max_match_distance = }")
    matches = []
    li = []
    result = 0
    for i, c in enumerate(s1):
        for j, d in enumerate(s2):
            if c == d and j not in li and abs(i-j) <= max_match_distance:
                matches.append((i+1, j+1))
                li.append(j)
                break

    for match1 in matches:
        for match2 in matches:
            if match1[0] < match2[0] and match1[1] > match2[1]:
                result += 1
    return result


def identical_character_length(s1, s2):
    result = 0
    for i, c in enumerate(s1):
        if s2[i] == c and result < 4:
            result += 1
        else:
            return result
    return result


def jaro_similarity(s1, s2):
    m = number_of_matches(s1, s2)
    t = number_of_transpositions(s1, s2)
    print(m, t, len(s1), len(s2))
    if m == 0:
        return 0
    else:
        sim_j = 1/3 * (m/(len(s1)) + m/(len(s2)) + (m-t)/m)
        return sim_j


def jaro_winkler_similarity(s1, s2):
    sim_j = jaro_similarity(s1, s2)
    l = identical_character_length(s1, s2)
    p = 0.1
    return sim_j + l*p*(1 - sim_j)


print(f'{jaro_winkler_similarity("Oberseestrasse", "Opersestrase") = }')
